<template>
    <div class="modal-background" id="outside_modal">
        <div class="study-data-wrapper" id="in_modal">
            <div class="study-data-grid">
                <div class="study-data-box study-data-tokens">
                    <div class="study-data-headline">Auth. Tokens</div>
                    <div class="existing-token" v-for="token of current_tokens">
                        <div>{{ token.token_id }}</div>
                        <div> {{ token.comment ? token.comment : 'No comment' }}</div>
                        <div> {{ token.auth_level }}</div>
                        <div> {{ token.date_expiration }}</div>
                        <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" style="cursor: pointer" 
                            @click="deleteAuthToken(token.token_id)"></Icon>
                    </div>
                    <div class="rule-grid-add" @click="adding_token = true" v-if="!adding_token">+</div>
                    <div class="existing-token" v-if="adding_token" style="margin-top: 10px;">
                        <div style="display: flex; gap: 8px;">{{ study_data?.study_id }}</div>
                        <input type="text" placeholder="Enter comment (optional)" style="max-width: 90%;" v-model="token_comment">
                        <select style="max-width: 90%;" v-model="token_perms">
                            <option selected value="viewer">Viewing Permissions</option>
                            <option value="contributor">Contributor Permissions</option>
                        </select>
                        <div style="display: flex;">
                            Expires in &nbsp;<input type="number" style="max-width: 25%;" value="0" v-model="token_exp">&nbsp; days
                        </div>
                        <Icon icon="mdi:tick" width="30" height="30" color="var(--color-primary)" class="icon" style="cursor: pointer;" @click="createAuthToken"/>
                    </div>
                </div>
                <div class="study-data-box study-data-metadata">
                    <div class="study-data-headline">Data & Metadata</div>
                    <div class="metadata-grid">
                        <div class="md-grid-item">
                            <div>&nbsp;Study ID</div>
                            <div>&nbsp;{{ study_data?.study_id }}</div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Study Name</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_name }}</div>
                            <div v-if="edit_mode">&nbsp;<input type="text" id="stn" :value="study_data?.study_name" @change="saveChange('stn','study_name')"></div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Visibility</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_visibility }}</div>
                            <div v-if="edit_mode"><select id="vis" @change="saveChange('vis', 'study_visibility')">
                                <option value="private" :selected="study_data?.study_visibility === 'private'">private</option>
                                <option value="public" :selected="study_data?.study_visibility === 'public'">public</option>
                                </select>
                            </div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Authors</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_author }}</div>
                            <div v-if="edit_mode">&nbsp;<input type="text" id="aut" :value="study_data?.study_author" @change="saveChange('aut','study_author')"></div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Analytical Method</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_type }}</div>
                            <div v-if="edit_mode"><select id="typ" @change="saveChange('typ', 'study_type')">
                                <option value="unknown" :selected="study_data?.study_type === 'unknown'">No information / unknown</option>
                                <option value="nmr" :selected="study_data?.study_type === 'nmr'">NMR</option>
                                <option value="lc-ms" :selected="study_data?.study_type === 'lc-ms'">LC-MS</option>
                                <option value="gc-ms" :selected="study_data?.study_type === 'gc-ms'">GC-MS</option>
                                <option value="multiple" :selected="study_data?.study_type === 'multiple'">Multiple</option>
                                <option value="other" :selected="study_data?.study_type === 'other'">Other</option>
                                </select>
                            </div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Biospecimen</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_specimen }}</div>
                            <div v-if="edit_mode"><select id="spc" @change="saveChange('spc', 'study_specimen')">
                                <option value="unknown" :selected="study_data?.study_specimen === 'unknown'">No information / unknown</option>
                                <option value="blood" :selected="study_data?.study_specimen === 'blood'">Blood</option>
                                <option value="urine" :selected="study_data?.study_specimen === 'urine'">Urine</option>
                                <option value="feces" :selected="study_data?.study_specimen === 'feces'">Feces</option>
                                <option value="csf" :selected="study_data?.study_specimen === 'csf'">Cerebral Spinal Fluid</option>
                                <option value="serum" :selected="study_data?.study_specimen === 'serum'">Serum</option>
                                <option value="plasma" :selected="study_data?.study_specimen === 'plasma'">Plasma</option>
                                <option value="multiple" :selected="study_data?.study_specimen === 'multiple'">Multiple</option>
                                <option value="other" :selected="study_data?.study_specimen === 'other'">Other</option>
                                </select>
                            </div>
                        </div>
                        <div class="md-grid-item">
                            <div>&nbsp;Date</div>
                            <div v-if="!edit_mode">&nbsp;{{ study_data?.study_date }}</div>
                            <div v-if="edit_mode">&nbsp;<input type="text" id="dat" :value="study_data?.study_date" pattern="[0-9_\- ]*" @change="saveChange('dat', 'study_date')"></div>
                        </div>
                        <div v-if="edit_object['study_metadata']" v-for="metadata_key in Object.keys(edit_object['study_metadata'])" class="md-grid-item">
                            <div v-if="edit_object['study_metadata']">&nbsp;{{ edit_object['study_metadata'][metadata_key].name }}</div>
                            <div v-if="edit_object['study_metadata'] && !edit_mode">&nbsp;{{ edit_object['study_metadata'][metadata_key].value }}</div>
                            <div v-if="edit_object['study_metadata'] && edit_mode">&nbsp;
                                <input type="text" :id="`metadata-${metadata_key}`" :value="edit_object['study_metadata'][metadata_key].value" pattern="[0-9_\- ]*" 
                                    @change="saveChange(`metadata-${metadata_key}`, metadata_key)" style="margin-left: -0.25rem;">
                            </div>
                            <Icon v-if="edit_object['study_metadata'] && edit_mode" icon="mdi:cancel" style="cursor: pointer;"
                                width="30" height="30" color="var(--color-primary)" @click="removeFromEditObject(metadata_key)"/>
                        </div>
                        <div v-if="edit_mode" class="md-grid-item">
                            <input type="text" id="new_md" placeholder="New metadata entry..."/>
                            <input type="text" id="new_md_value" placeholder="Value"/>
                            <Icon icon="mdi:tick" width="30" height="30" color="var(--color-primary)" @click="addToEditObject" style="cursor: pointer;"/>
                        </div>
                    </div>
                </div>
                <div class="study-data-box study-data-contributors">
                    <div class="study-data-headline">Contributors</div>
                    <div class="contributor-grid">
                        <div v-for="contributor in Object.keys(study_data?.study_members as Object)" style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div v-if="study_data?.study_metadata">&nbsp;{{ contributor }}</div>
                            <div v-if="study_data?.study_metadata">&nbsp;{{ study_data.study_members[contributor as keyof Object]}}</div>
                            <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" style="cursor: pointer" @click="revokeUser(contributor)"
                            v-if="study_data?.study_members[contributor as keyof object] != 'uploader'"/>
                        </div>
                        <div class="contributor-grid-add-row">
                            <input type="text" style="margin: 0.5rem;" v-model="add_username">
                            <div class="buttons" style="grid-column: 2; gap: 4px; width: max-content; padding-right: 0.25rem;">
                                <button style="font-size: 10px;" @click="addViewer">Add <br>Viewer</button>
                                <button style="font-size: 10px;" @click="addContributor">Add <br>Contributor</button>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="study-data-box study-data-phenotypes">
                    <div class="study-data-headline">Phenotypes</div>
                    <span v-if="!study_data?.study_phenotypes?.length">No phenotypes found!<br>You can add them by clicking "Manage study data".</span>
                    <span style="font-family: var(--ff-code)" v-for="phenotype in study_data?.study_phenotypes">{{ phenotype }}</span>
                </div>
            </div>
            <div class="buttons" style="margin-top: 0.5rem;">
                <button @click="toggleEditMode">{{ edit_mode ? "Cancel" : "Edit" }}</button>
                <button v-if="edit_mode" @click="saveAllEdits">Save</button>
                <button v-if="!edit_mode" @click="emit('manage-experimental-data')">Manage study data</button>
                <button v-if="!edit_mode" @click="emit('close-modal')">Close</button>
                <button v-if="!edit_mode" @click="delete_field_open = !delete_field_open">{{ delete_field_open ? 'Cancel' : 'Delete' }}</button>
                <input type="text" id="delete-field" style="width: 50ch" @keyup.enter="deleteThisStudy" v-if="delete_field_open" placeholder="Type 'delete' and press Enter to confirm."/>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useStudyStore } from '@/stores/studies';
import { onMounted, ref, watch, type PropType } from 'vue';
import { type StudyData } from '@/stores/studies';
import { updateUser, deleteStudy, getStudyList, updateStudy } from '@/modules/study_module';
import { Icon } from '@iconify/vue';
import  type { TokenData } from '@/modules/auth_module';
import { createToken, retrieveTokens, revokeToken } from '@/modules/auth_module';
import { useMessageStore, type Message } from '@/stores/message';
import type { ArbitraryObject } from '@/stores/query';

const studies = useStudyStore();
const msg = useMessageStore();

const emit = defineEmits<{
    'close-modal': [],
    'refresh-studies': [],
    'manage-experimental-data': [],
}>();

const props = defineProps({
    study_data: {} as PropType<StudyData>,
})

const addViewer = async () => {
    const res: Message = await updateUser(<string>props.study_data?.study_id, add_username.value, 'viewer');
    msg.add_message(res);
    await getStudyList();
};

const addContributor = async () => {
    const res: Message = await updateUser(<string>props.study_data?.study_id, add_username.value, 'contributor');
    msg.add_message(res);
    await getStudyList();
};

const revokeUser = async (username: string) => {
    if (!window.confirm("Do you really want to revoke study access for this user?")) return;
    const res: Message = await updateUser(<string>props.study_data?.study_id, username, 'revoke');
    msg.add_message(res);
    await getStudyList();
}

const deleteThisStudy = async () => {
    if ((document.getElementById('delete-field') as HTMLInputElement).value == 'delete') {
        const res: Message = await deleteStudy(<string>props.study_data?.study_id);
        msg.add_message(res);
        emit('close-modal');
        emit('refresh-studies');
    }
    await getStudyList();
}

const createAuthToken = async () => {
    const create_msg = await createToken([<string>props?.study_data?.study_id], token_perms.value, token_exp.value, token_comment.value);
    msg.add_message(create_msg);
    adding_token.value = false;
    current_tokens.value = await retrieveTokens(<string>props?.study_data?.study_id);
}

const deleteAuthToken = async (token_id: string) => {
    if (!window.confirm("Do you really want to delete this access token?")) return;
    const del_msg: Message = await revokeToken(token_id);
    msg.add_message(del_msg);
    current_tokens.value = await retrieveTokens(<string>props?.study_data?.study_id);
}

const toggleEditMode = () => {
    edit_mode.value = !edit_mode.value;
    msg.close_all();
}

const saveAllEdits = async () => {
    toggleEditMode();
    const res = await updateStudy(props!.study_data!.study_id, edit_object.value);
    msg.add_message(res);
    await getStudyList();
}

const saveChange = (html_id: string, input_key: string) => {
    if (input_key === 'study_id') return;
    let tgt = document.getElementById(html_id);
    if (tgt) {
        if (html_id.startsWith('metadata-')) {
            edit_object.value['study_metadata'][input_key] = {
                value: (tgt as HTMLInputElement).value,
                name: edit_object.value['study_metadata'][input_key].name,
                key: input_key
            };
        } else {
            edit_object.value[input_key] = (tgt as HTMLInputElement).value;
        } 
    } 
}

const addToEditObject = () => {
    let key = (document.getElementById('new_md') as HTMLInputElement).value;
    let value = (document.getElementById('new_md_value') as HTMLInputElement).value;
    const new_md_key = key.toLocaleLowerCase().replace(" ","_").replace("-","_");
    if (["study_id", "study_name", "study_visibility", "study_authors", "study_method", "study_type", "study_date"].includes(new_md_key)) {
        msg.add_message({msg: "Your metadata descriptor contains a protected keyword (probably something starting in 'study', please change it!)"});
        return;
    }
    edit_object.value['study_metadata'][new_md_key] = {
        value: value,
        name: key,
        key: new_md_key
    };
}

const removeFromEditObject = (key: string) => {
    delete edit_object.value['study_metadata'][key];
}

/**
 * On mounting, sets values for inside and outside the modal and stores them.
 */
 onMounted(async () => {
    initialized.value = false;
    if(document.getElementById("in_modal") && document.getElementById("in_modal") != undefined) {
        in_modal.value = document.getElementById("in_modal")
    }
    if(document.getElementById("outside_modal") && document.getElementById("outside_modal") != undefined) {
        outside_modal.value = document.getElementById("outside_modal")
    }
    initialized.value = true;
    current_tokens.value = await retrieveTokens(<string>props?.study_data?.study_id);
    edit_object.value = {study_metadata: props!.study_data!.study_metadata};
})

/**
 * Shows the modal if a user clicks inside the modal.
 * Closes it if a user clicks outside the modal.
 */
window.onclick = ((e: MouseEvent): void => {
    if (!initialized) {
        return;
    }
    if ((!in_modal.value || !outside_modal.value) || (e.target == outside_modal.value && e.target != in_modal.value)) {
        emit('close-modal')
    }
});

const add_username=ref<string>("");
const in_modal=ref<HTMLElement | null>();
const outside_modal=ref<HTMLElement | null>();
const initialized=ref(false);
const delete_field_open=ref<boolean>(false);
const adding_token=ref<boolean>(false);
const current_tokens = ref<TokenData[]>([]);
const edit_mode = ref<boolean>(false);

const token_comment = ref<string>("");
const token_exp = ref<number>(0);
const token_perms = ref<string>("viewer");
const edit_object = ref<ArbitraryObject>({});
</script>

<style scoped>

.contributor-grid-add-row {
    display: grid;
    grid-template-columns: 50% 40% 10%;
    grid-column: 1/4;
    grid-auto-flow: row;
    align-items: center;
}

.existing-token {
    width: 100%;
    display: grid;
    grid-template-columns: repeat(4, 1fr) 0.25fr;
    grid-column: 1/7;
    margin-left: 4px;
    align-items: center;
    text-align: center;
    justify-content: space-between;
}

.contributor-grid {
    display: grid;
    grid-template-columns: 50% 40% 10%;
    grid-auto-flow: column;
    align-items: center;
    justify-content: center;
    text-align: center;
    width: 100%;
    row-gap: 4px;
}

.metadata-grid {
    display: grid;
    grid-template-columns: 0.3fr 0.7fr 0.05fr;
    grid-auto-flow: column;
    align-items: center;
    width: 100%;
    row-gap: 4px;
}

.metadata-grid input {
    margin-top: 0.2rem;
    width: 100%;
    max-width: 90%;
}

.metadata-grid >*>*> select {
    margin-top: 0.2rem;
    margin-left: 0.25rem;
    padding: 0.2rem 0.5rem;
    max-width: fit-content;
}

.metadata-grid > *:nth-child(2n) {
    background-color: var(--color-bg-alt);
}

.study-data-headline {
    font-weight: bold;
    font-size: var(--fs-large);
    color: var(--color-bg);
    background-color: var(--color-head);
    width: 100%;
    text-align: center;
    grid-column: 1 / 6;
    grid-row: 1;
}
.study-data-wrapper {
    min-width: 75%;
    width: 90%;
    max-width: 100%;
    padding: 1rem;
    background-color: #fff;
    margin: auto;
    box-shadow: var(--sd-larger);
}

.study-data-metadata {
    grid-column: first-third / main-end;
    grid-row: first-third / main-end;
    background-color: var(--color-bg);
    max-height: 20rem;
}

.study-data-box {
    box-shadow: var(--sd-default);
    border: var(--bd-default);
    display: flex;
    align-items: center;
    flex-direction: column;
    overflow-x: hidden;
    overflow-y: auto;
}

.study-data-tokens {
    grid-column: first-third / main-end;
    grid-row: main-start;
    background-color: var(--color-bg);
    max-height: 10rem;
    display: grid;
    grid-template-columns: 1fr 1.5fr 1fr 1fr 0.25fr;
    align-items: baseline;
    justify-items: center;
    align-content: baseline;
    font-size: var(--fs-small)
}

.study-data-contributors {
    grid-column: main-start;
    grid-row: main-start / second-third;
    background-color: var(--color-bg);
    max-height: 20rem;
}

.study-data-phenotypes {
    grid-column: main-start;
    grid-row: second-third / main-end;
    background-color: var(--color-bg);
    max-height: 10rem;
}


.study-data-grid {
    display: grid;
    grid-template-columns: [main-start] 1.25fr [first-third] 1fr [second-third] 1fr [last-third] 1fr [main-end];
    grid-template-rows: [main-start] 1fr [first-third] 1fr [second-third] 1fr [main-end];
    background-color: var(--color-bg);
    min-height: 30rem;
    gap: 12px;
}

.md-grid-item {
    display: grid;
    grid-template-columns: subgrid;
    gap: 4px;
    grid-column: 1/4;
    align-items: center;
}

.md-grid-item input {
    margin: 0.2rem 0 0.2rem 6px;
    width: 100%;
    max-width: 90%;

}

</style>